module Dronejob
  module Loader
    @@workers = nil

    def self.load
      require "active_support/all"
      workers = {}
      Dir["#{Dronejob::Base.jobs_path}/*.rb"].each do |file|
        require "./#{file}"
        identifier = File.basename(file).gsub(/\.rb$/, "")
        klassname = identifier.camelcase
        klass = klassname.constantize
        workers[identifier] = klass
      end
      workers
    end

    def self.identifier_for(worker)
      self.workers.key(worker.class)
    end

    def self.workers(type = "base")
      type = type.to_s
      @@workers ||= load
      @@workers.select { |key, worker| worker::DRONEJOB_TYPE == type }
    end
  end
end
