module Dronejob
  module Modules
    module AttrStore
      extend ActiveSupport::Concern

      included do
        attr_accessor :variables
      end

      class_methods do
        def attr_store(*args)
          @attr_stores ||= [:dronejob_completed, :job_params, :job_identifier]
          @attr_stores.push(*args)
        end

        def attr_stores
          @attr_stores ||= [:dronejob_completed, :job_params, :job_identifier]
        end
      end

      def save_variables
        variables = {}
        self.class.attr_stores.each do |key|
          variables[key] = instance_variable_get("@#{key}")
        end
        yaml_file = working_dir.file("dronejob.yml")
        yaml_file.write(Psych.dump(variables))
      end

      def load_variables
        yaml_file = working_dir.file("dronejob.yml")
        variables = yaml_file.exists? ? yaml_file.read_yaml : {}
        variables.each do |key, value|
          instance_variable_set("@#{key}", value)
        end
      end
    end
  end
end
