module Dronejob
  module Modules
    module Callbacks
      extend ActiveSupport::Concern
      include ActiveSupport::Callbacks

      included do
        define_callbacks :phase
        define_callbacks :job
      end

      class_methods do
        def before_phase(*methods, &block)
          set_callback(:phase, :before, *methods, &block)
        end

        def after_phase(*methods, &block)
          set_callback(:phase, :after, *methods, &block)
        end

        def before_job(*methods, &block)
          set_callback(:job, :before, *methods, &block)
        end

        def after_job(*methods, &block)
          set_callback(:job, :after, *methods, &block)
        end
      end
    end
  end
end
