module Dronejob
  module Modules
    module Core
      extend ActiveSupport::Concern

      included do
        attr_reader :commits, :config
      end

      def perform(params)
        @job_params = params.to_h
        @job_identifier = Dronejob::Loader.identifier_for(self)
        self.params = params
        validate_parameters!
        run_callbacks :job do
          run_phases
        end
      end

      def shell
        @shell ||= Thor::Shell::Color.new
      end

      def ask(*args)
        shell.ask(*args)
      end

      def say(*args)
        shell.say(*args)
      end

      def breakpoint
        if param(:break)
          say("                            ", [Thor::Shell::Color::WHITE, Thor::Shell::Color::ON_BLACK], true)
          say("    BREAKPOINT ACTIVATED    ", [Thor::Shell::Color::WHITE, Thor::Shell::Color::ON_BLACK, Thor::Shell::Color::BOLD], true)
          say("  PRESS RETURN TO CONTINUE  ", [Thor::Shell::Color::WHITE, Thor::Shell::Color::ON_BLACK], true)
          say("                            ", [Thor::Shell::Color::WHITE, Thor::Shell::Color::ON_BLACK], false)
          ask("")
        end
      end
    end
  end
end
