module Dronejob
  module Modules
    module Options
      extend ActiveSupport::Concern

      included do
        attr_reader :options
      end

      class_methods do
        def options
          if @options.nil?
            yaml_file = File.join("dronejob.yml")
            yaml_options = File.exist?(yaml_file) ? Psych.load_file(yaml_file) : default_options
            @options = OpenStruct.new(default_options.merge(yaml_options))
          end
          @options
        end

        def option(key)
          options.send(key)
        end

        def default_options
          { redis_url: "redis://127.0.0.1:6379" }
        end
      end

      def options
        self.class.options
      end

      def option(key)
        self.class.option(key)
      end
    end
  end
end
